//set directory
global path "C:\Users\Reina Kawai\Downloads\resavingpurpose\input files_non-MONA"

cd "${path}"
clear
set more off
	
*********************************************
// figure 1: prediction-realization diagram
// full sample
*********************************************
use "X_M_E_6-27-21_updated.dta", clear


sum      actual_NM_usd  forecast_NM_usd 
sum      actual_NX_usd  forecast_NX_usd
sum      actual_RENDA  forecast_RENDA   


use "X_M_E_6-27-21_updated.dta", clear	   

local    v="NM_usd"
*keep    if  actual_`v'!=.  &  forecast_`v'!=.
twoway (scatter actual_`v' forecast_`v', msymbol(Oh) color(gs5) msize(tiny)) ///
       (lfitci actual_`v' forecast_`v', clpat(dash) clcolor(orange) )  ///
	   (function x y, range(-0.3 1.47) lcolor(midgreen) lwidth(medthick)), ///
	    xsc(range(-1 0.3)) ysc(range(-0.25 0.3)) ///
	   xla(-1 "-1" -0.5 "-0.5"  0 "0" 0.5 "0.5" 1 "1" 1.5 "1.5" 2 "2" 2.5 "2.5") ///
       yla(-1 "-1" -0.5 "-0.5"  0 "0" 0.5 "0.5" 1 "1" 1.5 "1.5" 2 "2" 2.5 "2.5", angle(h)) ///
	   ytitle("Actual Outcome Data (WEO)")  xtitle("Program Forecast (MONA)")  ///
       name(NM_usd, replace) legend(off ) ///
	   saving(NM_usd, replace) scheme(s1mono) aspect(1)		


use "X_M_E_6-27-21_updated.dta", clear	   
local    v="NX_usd"
*keep    if  actual_`v'!=.  &  forecast_`v'!=.
twoway (scatter actual_`v' forecast_`v', msymbol(Oh) color(gs5) msize(tiny)) ///
       (lfitci actual_`v' forecast_`v', clpat(dash) clcolor(orange) )  ///
	   (function x y, range(-0.3 1.2) lcolor(midgreen) lwidth(medthick)), ///
	   xsc(range(-1 2)) ysc(range(-0.8 2))  ///
	   xla(-1 "1" -0.5 "-0.5" 0 "0" 0.5 "0.5" 1 "1" 1.5 "1.5" 2 "2") ///
       yla(-1 "1" -0.5 "-0.5" 0 "0" 0.5 "0.5" 1 "1" 1.5 "1.5" 2 "2", angle(h)) ///
	   ytitle("Actual Outcome Data (WEO)")  xtitle("Program Forecast (MONA)")  ///
       name(NX_usd, replace)  legend(off ) ///
	   saving(NX_usd, replace) scheme(s1mono) aspect(1) 
	   graph export "NX_RER.png",  width(300) height(300)  replace	   

	   
	   
use "X_M_E_6-27-21_updated.dta", clear	   
local    v="RENDA"
*keep    if  actual_`v'!=.  &  forecast_`v'!=.
twoway (scatter actual_`v' forecast_`v', msymbol(Oh) color(gs5) msize(tiny)) ///
       (lfitci actual_`v' forecast_`v', clpat(dash) clcolor(orange) )  ///
	   (function x y, range(-3.8 5.2) lcolor(midgreen) lwidth(medthick)), ///
	    xsc(range(-4 6)) ysc(range(-4 6)) ///
	   xla( -4 "-4" -3 "-3" -2 "-2" -1 "-1" 0 "0" 1 "1"  2 "2" 3 "3" 4 "4"  5 "5" 6 "6" ) ///
       yla(-4 "-4" -3 "-3" -2 "-2" -1 "-1" 0 "0" 1 "1"  2 "2" 3 "3" 4 "4"  5 "5" 6 "6" , angle(h)) ///
	   ytitle("Actual Outcome Data (WEO)")  xtitle("Program Forecast (MONA)")  ///
       name(NX_usd, replace) legend(off ) ///
	   saving(NX_usd, replace) scheme(s1mono) 
	   graph export "RENDA_RER.png", width(270) height(300) replace
  	   

	   
	   
*********************************************
// Figure 2.1: Nowcast Bias and Efficiency Over Time 
// full sample
*********************************************
// set path
cd "${path}"
clear
set more off

*****************  NM, full sample *****************  
use        "X_M_E_6-27-21_updated.dta", clear

local     def_var  = "NM_usd"	         // 1. rename variable here!!!!!!!!!!!!!
gen        mneumonic="`def_var'"


rename     actual_`def_var'       actual       
rename     forecast_`def_var'     forecast    
rename     fe_imf_`def_var'       ferror
sum        actual forecast ferror

drop       type_new_LT_BOP // 2. omit this type (least obs)


save tempdata.dta, replace

use tempdata.dta, clear


	
// PART 1: regression by 5-year rolling window

	forvalues i=1992(1)2015 {

	
	
	local j=`i'+4
		* SJS F-test:
	reg       actual forecast         if programyear>=`i' & programyear<=`j' , robust   // start with no control vairables at all
	est       store yr`j'  
	gen       sample_end`j' = e(sample)  
	test      (_b[_cons]=0)           
	local     pval_alphais0=r(p)
	test      (_b[forecast]=1)           
	local     pval_betais1=r(p)
	test      (_b[_cons]=0) (_b[forecast]=1)  
	local     Fval=r(F)
	local     pval_F=r(p)
	local     adj_r=e(r2_a)
	* Holden-Peel T test:
	reg       ferror                  if programyear>=`i' & programyear<=`j' , robust
	local     tstat_gamma = (_b[_cons]/_se[_cons]) 
	local     pval_gamma = tprob(e(df_r), abs(`tstat_gamma'))
	* Results output:
	outreg2   [yr`j']  using "reg_5Yrolling_`def_var'.xls", ///
	          adds(Adjusted R-squared, `adj_r', p-value (alpha=0), `pval_alphais0', p-value (beta=1), `pval_betais1', MZ F-test (alpha=0 & beta=1), `Fval', ///
	          p-value (alpha=0 & beta=1), `pval_F', Holden-Peel T-Test (gamma=0), `tstat_gamma', p-value, `pval_gamma' ) excel dec(2) 
        }

		
		
// Export result to the master output file
import   delimited  "reg_5Yrolling_`def_var'.txt",  clear
export   excel using "Output_IMFNowcasts_June27_2021.xlsx", sheet("Figure4.1_reg_`def_var'", replace)  firstrow(variables)



// plot coefficients of forecasts and 95% CI, export plot data		  
coefplot  yr1996 yr1997	yr1998	yr1999  yr2000 ///
          yr2001 yr2002	yr2003	yr2004	yr2005 yr2006	yr2007	yr2008 yr2009 yr2010 ///
		  yr2011 yr2012 yr2013	yr2014	yr2015 yr2016	yr2017	yr2018 yr2019 , ///
		  vertical drop(_cons) yline(1)  gen(ep_)  legend(col(5))

		  
// export data to make the graph easier to read
keep  ep_*
drop if ep_b==.
gen     endyear=1996
replace endyear=endyear - 1 +[_n]


// add marker to show bias and inefficiency
tsset    endyear, yearly
gen        mneumonic="`def_var'"

if mneumonic  == "NM_usd" {	
gen      biased=.
replace  biased = ep_b             if  inlist(endyear, 1996) | inrange(endyear, 2000, 2003) | inrange(endyear, 2006, 2008)  | inrange(endyear, 2015, 2019)
gen      inefficient=.
replace  inefficient=ep_b          if   inlist(endyear, 1996, 2010) | inrange(endyear, 2000, 2008)  | inrange(endyear, 2014, 2019)
gen      biased_inefficient=.
replace  biased_inefficient=ep_b   if biased != .   &  inefficient!=. 
gen      only_inefficient =.        
replace  only_inefficient = ep_b        if  inefficient!=. & biased==.

twoway   (line ep_b endyear,  lwidth(thick)) ///
         (line ep_ll1 endyear,  lpattern(dash) lcolor(gs8)) ///
		 (line ep_ul1 endyear,  lpattern(dash) lcolor(gs8))  ///
		 (scatter only_inefficient endyear, mcolor(gold)  msize(medsmall) msymbol(0)) ///
		 (scatter biased endyear, mcolor(orange) msize(large) mlwidth(medthick) msymbol(O))  ///
		 (scatter biased_inefficient endyear, mcolor(gold)  msize(medsmall) msymbol(0)),  yline(1, lwidth(thick) lcolor(white) lpattern(solid)) ///
         yla(-1 "-1" 0 "0" 1 "1" 2 "2" 3 "3", angle(h)) ///
		 legend(order(1 "Coef of forecast" 2 "95% CI" 3 "95% CI" 4 "Inefficient" 5 "Biased") cols(3) position(6) ) ///
		 xlabel(1996(1)2019, labsize(medium) angle(vertical) nogrid) title("(2.1a) Import Growth", size(large)) ///
		 ylabel(, labsize(medlarge) angle(h)) ///
		 xtitle("End Year of the 5-year Rolling Window", size(medlarge)) ///
		 saving("`def_var'_5y_rolling", replace) name("`def_var'", replace)  scheme(plottig) aspect(0.5)

}




// erase at the end
erase  "reg_5Yrolling_`def_var'.xls"
erase  "reg_5Yrolling_`def_var'.txt"
erase  tempdata.dta	
*erase  graphdata.dta






*****************  NX_usd, full sample *****************  
use        "X_M_E_6-27-21_updated.dta", clear

local     def_var  = "NX_usd"	         // 1. rename variable here!!!!!!!!!!!!!
gen        mneumonic="`def_var'"


rename     actual_`def_var'       actual       
rename     forecast_`def_var'     forecast    
rename     fe_imf_`def_var'       ferror
sum        actual forecast ferror

drop       type_new_LT_BOP // 2. omit this type (least obs)


save tempdata.dta, replace

use tempdata.dta, clear


	
// PART 1: regression by 5-year rolling window

	forvalues i=1992(1)2015 {
	
	local j=`i'+4
		* SJS F-test:
	reg       actual forecast         if programyear>=`i' & programyear<=`j' , robust   // start with no control vairables at all
	est       store yr`j'  
	gen       sample_end`j' = e(sample)  
	test      (_b[_cons]=0)           
	local     pval_alphais0=r(p)
	test      (_b[forecast]=1)           
	local     pval_betais1=r(p)
	test      (_b[_cons]=0) (_b[forecast]=1)  
	local     Fval=r(F)
	local     pval_F=r(p)
	local     adj_r=e(r2_a)
	* Holden-Peel T test:
	reg       ferror                  if programyear>=`i' & programyear<=`j' , robust
	local     tstat_gamma = (_b[_cons]/_se[_cons]) 
	local     pval_gamma = tprob(e(df_r), abs(`tstat_gamma'))
	* Results output:
	outreg2   [yr`j']  using "reg_5Yrolling_`def_var'.xls", ///
	          adds(Adjusted R-squared, `adj_r', p-value (alpha=0), `pval_alphais0', p-value (beta=1), `pval_betais1', MZ F-test (alpha=0 & beta=1), `Fval', ///
	          p-value (alpha=0 & beta=1), `pval_F', Holden-Peel T-Test (gamma=0), `tstat_gamma', p-value, `pval_gamma' ) excel dec(2) 
        }

// Export result to the master output file
import   delimited  "reg_5Yrolling_`def_var'.txt",  clear
export   excel using "Output_IMFNowcasts_June27_2021.xlsx", sheet("Figure4.1_reg_`def_var'", replace)  firstrow(variables)



// plot coefficients of forecasts and 95% CI, export plot data		  
coefplot  yr1996 yr1997	yr1998	yr1999  yr2000 ///
          yr2001 yr2002	yr2003	yr2004	yr2005 yr2006	yr2007	yr2008 yr2009 yr2010 ///
		  yr2011 yr2012 yr2013	yr2014	yr2015 yr2016	yr2017	yr2018 yr2019 , ///
		  vertical drop(_cons) yline(1)  gen(ep_)  legend(col(5))

		  
// export data to make the graph easier to read
keep  ep_*
drop if ep_b==.
gen     endyear=1996
replace endyear=endyear - 1 +[_n]


// add marker to show bias and inefficiency
tsset    endyear, yearly
gen        mneumonic="`def_var'"


if mneumonic  == "NX_usd" {	
gen      biased=.
replace  biased = ep_b             if inrange(endyear, 1996, 1998) | inrange(endyear, 2004, 2013)
gen      inefficient=.
replace  inefficient=ep_b          if  inrange(endyear, 1996, 1998) | inrange(endyear, 2004, 2013)
gen      biased_inefficient=.
replace  biased_inefficient=ep_b   if biased != .   &  inefficient!=. 
gen      only_inefficient =.        
replace  only_inefficient = ep_b        if  inefficient!=. & biased==.

twoway   (line ep_b endyear,  lwidth(thick)) ///
         (line ep_ll1 endyear,  lpattern(dash) lcolor(gs8)) ///
		 (line ep_ul1 endyear,  lpattern(dash) lcolor(gs8))  ///
		 (scatter only_inefficient endyear, mcolor(gold)  msize(medsmall) msymbol(0)) ///
		 (scatter biased endyear, mcolor(orange) msize(large) mlwidth(medthick) msymbol(O))  ///
		 (scatter biased_inefficient endyear, mcolor(gold)  msize(medsmall) msymbol(0)),  yline(1, lwidth(thick) lcolor(white) lpattern(solid)) ///
         yla(-1 "-1" 0 "0" 1 "1" 2 "2" 3 "3", angle(h)) ///
		 legend(order(1 "Coef of forecast" 2 "95% CI" 3 "95% CI" 4 "Inefficient" 5 "Biased") cols(3) position(6) ) ///
		 xlabel(1996(1)2019, labsize(medium) angle(vertical) nogrid) title("(2.1b) Export Growth", size(large)) ///
		 ylabel(, labsize(medlarge) angle(h)) ///
		 xtitle("End Year of the 5-year Rolling Window", size(medlarge)) ///
		 saving("`def_var'_5y_rolling", replace) name("`def_var'", replace)  scheme(plottig) aspect(0.5)

}
   

		
/*		
grc1leg   ENDA NM_usd NX_usd, col(3) ring(0)  legendfrom(ENDA) name(Fig4_1, replace) ///
          title("Nowcast Bias and Efficiency Over Time, 5-year Rolling Window")  subtitle("full sample")
graph     display Fig4_1, ysize(4) xsize(10)
*/


// erase at the end
erase  "reg_5Yrolling_`def_var'.xls"
erase  "reg_5Yrolling_`def_var'.txt"
erase  tempdata.dta	
*erase  graphdata.dta




*****************  RENDA, full sample *****************  
use        "X_M_E_6-27-21_updated.dta", clear

local     def_var  = "RENDA"	         // 1. rename variable here!!!!!!!!!!!!!
gen        mneumonic="`def_var'"


rename     actual_`def_var'       actual       
rename     forecast_`def_var'     forecast    
rename     fe_imf_`def_var'       ferror
sum        actual forecast ferror

drop       type_new_LT_BOP // 2. omit this type (least obs)


save tempdata.dta, replace

use tempdata.dta, clear


	
// PART 1: regression by 5-year rolling window

	forvalues i=1992(1)2015 {
	
	local j=`i'+4
		* SJS F-test:
	reg       actual forecast         if programyear>=`i' & programyear<=`j' , robust   // start with no control vairables at all
	est       store yr`j'  
	gen       sample_end`j' = e(sample)  
	test      (_b[_cons]=0)           
	local     pval_alphais0=r(p)
	test      (_b[forecast]=1)           
	local     pval_betais1=r(p)
	test      (_b[_cons]=0) (_b[forecast]=1)  
	local     Fval=r(F)
	local     pval_F=r(p)
	local     adj_r=e(r2_a)
	* Holden-Peel T test:
	reg       ferror                  if programyear>=`i' & programyear<=`j' , robust
	local     tstat_gamma = (_b[_cons]/_se[_cons]) 
	local     pval_gamma = tprob(e(df_r), abs(`tstat_gamma'))
	* Results output:
	outreg2   [yr`j']  using "reg_5Yrolling_`def_var'.xls", ///
	          adds(Adjusted R-squared, `adj_r', p-value (alpha=0), `pval_alphais0', p-value (beta=1), `pval_betais1', MZ F-test (alpha=0 & beta=1), `Fval', ///
	          p-value (alpha=0 & beta=1), `pval_F', Holden-Peel T-Test (gamma=0), `tstat_gamma', p-value, `pval_gamma' ) excel dec(2) 
        }



// Export result to the master output file
import   delimited  "reg_5Yrolling_`def_var'.txt",  clear
export   excel using "Output_IMFNowcasts_June27_2021.xlsx", sheet("Figure4.1_reg_`def_var'", replace)  firstrow(variables)



// plot coefficients of forecasts and 95% CI, export plot data		  
coefplot  yr1996 yr1997	yr1998	yr1999  yr2000 ///
          yr2001 yr2002	yr2003	yr2004	yr2005 yr2006	yr2007	yr2008 yr2009 yr2010 ///
		  yr2011 yr2012 yr2013	yr2014	yr2015 yr2016	yr2017	yr2018 yr2019 , ///
		  vertical drop(_cons) yline(1)  gen(ep_)  legend(col(5))

		  
// export data to make the graph easier to read
keep  ep_*
drop if ep_b==.
gen     endyear=1996
replace endyear=endyear - 1 +[_n]


// add marker to show bias and inefficiency
tsset    endyear, yearly
gen        mneumonic="`def_var'"


if  mneumonic  == "RENDA" {	

gen      biased=.
replace  biased = ep_b             if  inlist(endyear, 1996, 1997)  | inrange(endyear, 2007, 2010)| inrange(endyear, 2013, 2017)
gen      inefficient=.
replace  inefficient=ep_b          if  inlist(endyear, 1996, 1997)  | inrange(endyear, 2007, 2019)
gen      biased_inefficient=.
replace  biased_inefficient=ep_b   if biased != .   &  inefficient!=. 
gen      only_inefficient =.        
replace  only_inefficient = ep_b        if  inefficient!=. & biased==.

twoway   (line ep_b endyear,  lwidth(thick)) ///
         (line ep_ll1 endyear,  lpattern(dash) lcolor(gs8)) ///
		 (line ep_ul1 endyear,  lpattern(dash) lcolor(gs8))  ///
		 (scatter only_inefficient endyear, mcolor(gold)  msize(medsmall) msymbol(0)) ///
		 (scatter biased endyear, mcolor(orange) msize(large) mlwidth(medthick) msymbol(O))  ///
		 (scatter biased_inefficient endyear, mcolor(gold)  msize(medsmall) msymbol(0)),  yline(1, lwidth(thick) lcolor(white) lpattern(solid)) ///
         yla(-1 "-1" 0 "0" 1 "1" 2 "2" 3 "3", angle(h)) ///
		 legend(order(1 "Coef of forecast" 2 "95% CI" 3 "95% CI" 4 "Inefficient" 5 "Biased") cols(3) position(6) ) ///
		 xlabel(1996(1)2019, labsize(medium) angle(vertical) nogrid) title("(2.1c) Real Exchange Rate Growth", size(large)) ///
		 ylabel(, labsize(medlarge) angle(h)) ///
		 xtitle("End Year of the 5-year Rolling Window", size(medlarge)) ///
		 saving("`def_var'_5y_rolling", replace) name("`def_var'", replace)  scheme(plottig) aspect(0.5)
}

grc1leg   NM_usd NX_usd RENDA, col(3) ring(0)  legendfrom(NM_usd) name(Fig4_1, replace) ///
          title("Nowcast Bias and Efficiency Over Time, 5-year Rolling Window")  subtitle("full sample")
graph     display Fig4_1, ysize(4) xsize(10)





// erase at the end
//erase  "reg_5Yrolling_`def_var'.xls"
//erase  "reg_5Yrolling_`def_var'.txt"
erase  tempdata.dta	
*erase  graphdata.dta

*********************************************
// Figure 2.2: Nowcast Bias and Efficiency Over Time 
// Non Hyperinflation & LIC
*********************************************
cd "${path}"
clear
set more off
*****************  NM_usd, Non Hyperinflation & LIC *****************  
use        "X_M_E_6-27-21_updated.dta", clear
keep      if  dummy_LIC == 1  &  dummy_hyper == 0        // LIC + non-hyper

local     def_var  = "NM_usd"	         // 1. rename variable here!!!!!!!!!!!!!
gen        mneumonic="`def_var'"


rename     actual_`def_var'       actual       
rename     forecast_`def_var'     forecast    
rename     fe_imf_`def_var'       ferror
sum        actual forecast ferror

drop       type_new_LT_BOP // 2. omit this type (least obs)


save tempdata.dta, replace

use tempdata.dta, clear


	
// PART 1: regression by 5-year rolling window

	forvalues i=1992(1)2015 {
	
	local j=`i'+4
		* SJS F-test:
	reg       actual forecast         if programyear>=`i' & programyear<=`j' , robust   // start with no control vairables at all
	est       store yr`j'  
	gen       sample_end`j' = e(sample)  
	test      (_b[_cons]=0)           
	local     pval_alphais0=r(p)
	test      (_b[forecast]=1)           
	local     pval_betais1=r(p)
	test      (_b[_cons]=0) (_b[forecast]=1)  
	local     Fval=r(F)
	local     pval_F=r(p)
	local     adj_r=e(r2_a)
	* Holden-Peel T test:
	reg       ferror                  if programyear>=`i' & programyear<=`j' , robust
	local     tstat_gamma = (_b[_cons]/_se[_cons]) 
	local     pval_gamma = tprob(e(df_r), abs(`tstat_gamma'))
	* Results output:
	outreg2   [yr`j']  using "reg_5Yrolling_`def_var'.xls", ///
	          adds(Adjusted R-squared, `adj_r', p-value (alpha=0), `pval_alphais0', p-value (beta=1), `pval_betais1', MZ F-test (alpha=0 & beta=1), `Fval', ///
	          p-value (alpha=0 & beta=1), `pval_F', Holden-Peel T-Test (gamma=0), `tstat_gamma', p-value, `pval_gamma' ) excel dec(2)
        }

// Export result to the master output file
import   delimited  "reg_5Yrolling_`def_var'.txt",  clear
export   excel using "Output_IMFNowcasts_June27_2021.xlsx", sheet("Figure4.2_reg_`def_var'", replace)  firstrow(variables)



// plot coefficients of forecasts and 95% CI, export plot data		  
coefplot  yr1996 yr1997	yr1998	yr1999  yr2000 ///
          yr2001 yr2002	yr2003	yr2004	yr2005 yr2006	yr2007	yr2008 yr2009 yr2010 ///
		  yr2011 yr2012 yr2013	yr2014	yr2015 yr2016	yr2017	yr2018 yr2019 , ///
		  vertical drop(_cons) yline(1)  gen(ep_)  legend(col(5))

		  
// export data to make the graph easier to read
keep  ep_*
drop if ep_b==.
gen     endyear=1996
replace endyear=endyear - 1 +[_n]


// add marker to show bias and inefficiency
tsset    endyear, yearly
gen        mneumonic="`def_var'"


if mneumonic  == "NM_usd" {	
gen      biased=.
replace  biased = ep_b             if   inlist(endyear, 1996)  | inrange(endyear, 2000, 2004)  | inrange(endyear, 2006, 2008) | inrange(endyear, 2010, 2011) | inrange(endyear, 2015, 2019)
gen      inefficient=.
replace  inefficient=ep_b          if  inlist(endyear, 1996)  | inrange(endyear, 2000, 2019) 
gen      biased_inefficient=.
replace  biased_inefficient=ep_b   if biased != .   &  inefficient!=. 
gen      only_inefficient =.        
replace  only_inefficient = ep_b        if  inefficient!=. & biased==.

twoway   (line ep_b endyear,  lwidth(thick)) ///
         (line ep_ll1 endyear,  lpattern(dash) lcolor(gs8)) ///
		 (line ep_ul1 endyear,  lpattern(dash) lcolor(gs8))  ///
		 (scatter only_inefficient endyear, mcolor(gold)  msize(medsmall) msymbol(0)) ///
		 (scatter biased endyear, mcolor(orange) msize(large) mlwidth(medthick) msymbol(O))  ///
		 (scatter biased_inefficient endyear, mcolor(gold)  msize(medsmall) msymbol(0)),  yline(1, lwidth(thick) lcolor(white) lpattern(solid)) ///
		 legend(order(1 "Coef of forecast" 2 "95% CI" 3 "95% CI" 4 "Inefficient" 5 "Biased") cols(3) position(6) ) ///
		 xlabel(1996(1)2019, labsize(small) angle(vertical) nogrid) title("(4.2a) Import Growth", size(large)) ///
		 ylabel(, labsize(medlarge) angle(h)) ///
		 xtitle("End Year of the 5-year Rolling Window", size(medlarge)) ///
		 saving("`def_var'_5y_rolling", replace) name("`def_var'", replace)  scheme(plottig) aspect(0.5)
}



// erase at the end
erase  "reg_5Yrolling_`def_var'.xls"
erase  "reg_5Yrolling_`def_var'.txt"
erase  tempdata.dta	
*erase  graphdata.dta






*****************  NX_usd, Non Hyperinflation & LIC *****************  
use        "X_M_E_6-27-21_updated.dta", clear
keep      if  dummy_LIC == 1  &  dummy_hyper == 0        // LIC + non-hyper

local     def_var  = "NX_usd"	         // 1. rename variable here!!!!!!!!!!!!!
gen        mneumonic="`def_var'"


rename     actual_`def_var'       actual       
rename     forecast_`def_var'     forecast    
rename     fe_imf_`def_var'       ferror
sum        actual forecast ferror

drop       type_new_LT_BOP // 2. omit this type (least obs)


save tempdata.dta, replace

use tempdata.dta, clear


	
// PART 1: regression by 5-year rolling window

	forvalues i=1992(1)2015 {
	
	local j=`i'+4
		* SJS F-test:
	reg       actual forecast         if programyear>=`i' & programyear<=`j' , robust   // start with no control vairables at all
	est       store yr`j'  
	gen       sample_end`j' = e(sample)  
	test      (_b[_cons]=0)           
	local     pval_alphais0=r(p)
	test      (_b[forecast]=1)           
	local     pval_betais1=r(p)
	test      (_b[_cons]=0) (_b[forecast]=1)  
	local     Fval=r(F)
	local     pval_F=r(p)
	local     adj_r=e(r2_a)
	* Holden-Peel T test:
	reg       ferror                  if programyear>=`i' & programyear<=`j' , robust
	local     tstat_gamma = (_b[_cons]/_se[_cons]) 
	local     pval_gamma = tprob(e(df_r), abs(`tstat_gamma'))
	* Results output:
	outreg2   [yr`j']  using "reg_5Yrolling_`def_var'.xls", ///
	          adds(Adjusted R-squared, `adj_r', p-value (alpha=0), `pval_alphais0', p-value (beta=1), `pval_betais1', MZ F-test (alpha=0 & beta=1), `Fval', ///
	          p-value (alpha=0 & beta=1), `pval_F', Holden-Peel T-Test (gamma=0), `tstat_gamma', p-value, `pval_gamma' ) excel dec(2) 
        }

// Export result to the master output file
import   delimited  "reg_5Yrolling_`def_var'.txt",  clear
export   excel using "Output_IMFNowcasts_June27_2021.xlsx", sheet("Figure4.2_reg_`def_var'", replace)  firstrow(variables)



// plot coefficients of forecasts and 95% CI, export plot data		  
coefplot  yr1996 yr1997	yr1998	yr1999  yr2000 ///
          yr2001 yr2002	yr2003	yr2004	yr2005 yr2006	yr2007	yr2008 yr2009 yr2010 ///
		  yr2011 yr2012 yr2013	yr2014	yr2015 yr2016	yr2017	yr2018 yr2019 , ///
		  vertical drop(_cons) yline(1)  gen(ep_)  legend(col(5))

		  
// export data to make the graph easier to read
keep  ep_*
drop if ep_b==.
gen     endyear=1996
replace endyear=endyear - 1 +[_n]


// add marker to show bias and inefficiency
tsset    endyear, yearly
gen        mneumonic="`def_var'"


if mneumonic  == "NX_usd" {	
gen      biased=.
replace  biased = ep_b             if  inlist(endyear, 1996)  | inrange(endyear, 2006, 2011)
gen      inefficient=.
replace  inefficient=ep_b          if   inrange(endyear, 2007, 2011)  | inrange(endyear, 2013, 2016)   
gen      biased_inefficient=.
replace  biased_inefficient=ep_b   if biased != .   &  inefficient!=. 
gen      only_inefficient =.        
replace  only_inefficient = ep_b        if  inefficient!=. & biased==.

twoway   (line ep_b endyear,  lwidth(thick)) ///
         (line ep_ll1 endyear,  lpattern(dash) lcolor(gs8)) ///
		 (line ep_ul1 endyear,  lpattern(dash) lcolor(gs8))  ///
		 (scatter only_inefficient endyear, mcolor(gold)  msize(medsmall) msymbol(0)) ///
		 (scatter biased endyear, mcolor(orange) msize(large) mlwidth(medthick) msymbol(O))  ///
		 (scatter biased_inefficient endyear, mcolor(gold)  msize(medsmall) msymbol(0)),  yline(1, lwidth(thick) lcolor(white) lpattern(solid)) ///
		 legend(order(1 "Coef of forecast" 2 "95% CI" 3 "95% CI" 4 "Inefficient" 5 "Biased") cols(3) position(6) ) ///
		 xlabel(1996(1)2019, labsize(small) angle(vertical) nogrid) title("(4.2b) Export Growth", size(large)) ///
		 ylabel(, labsize(medlarge) angle(h)) ///
		 xtitle("End Year of the 5-year Rolling Window", size(medlarge)) ///
		 saving("`def_var'_5y_rolling", replace) name("`def_var'", replace)  scheme(plottig) aspect(0.5)
}
   
/*		
grc1leg   ENDA NM_usd NX_usd, col(3) ring(0)  legendfrom(ENDA) name(Fig4_2, replace) ///
          title("Nowcast Bias and Efficiency Over Time, 5-year Rolling Window")  subtitle("Non Hyperinflation & LIC")
graph     display Fig4_2, ysize(4) xsize(10)
*/




*****************  RENDA, Non Hyperinflation & LIC *****************  
use        "X_M_E_6-27-21_updated.dta", clear
keep      if  dummy_LIC == 1  &  dummy_hyper == 0        // LIC + non-hyper

local     def_var  = "RENDA"	         // 1. rename variable here!!!!!!!!!!!!!
gen        mneumonic="`def_var'"


rename     actual_`def_var'       actual       
rename     forecast_`def_var'     forecast    
rename     fe_imf_`def_var'       ferror
sum        actual forecast ferror

drop       type_new_LT_BOP // 2. omit this type (least obs)


save tempdata.dta, replace

use tempdata.dta, clear


	
// PART 1: regression by 5-year rolling window

	forvalues i=1992(1)2015 {
	
	local j=`i'+4
		* SJS F-test:
	reg       actual forecast         if programyear>=`i' & programyear<=`j' , robust   // start with no control vairables at all
	est       store yr`j'  
	gen       sample_end`j' = e(sample)  
	test      (_b[_cons]=0)           
	local     pval_alphais0=r(p)
	test      (_b[forecast]=1)           
	local     pval_betais1=r(p)
	test      (_b[_cons]=0) (_b[forecast]=1)  
	local     Fval=r(F)
	local     pval_F=r(p)
	local     adj_r=e(r2_a)
	* Holden-Peel T test:
	reg       ferror                  if programyear>=`i' & programyear<=`j' , robust
	local     tstat_gamma = (_b[_cons]/_se[_cons]) 
	local     pval_gamma = tprob(e(df_r), abs(`tstat_gamma'))
	* Results output:
	outreg2   [yr`j']  using "1reg_5Yrolling_`def_var'.xls", ///
	          adds(Adjusted R-squared, `adj_r', p-value (alpha=0), `pval_alphais0', p-value (beta=1), `pval_betais1', MZ F-test (alpha=0 & beta=1), `Fval', ///
	          p-value (alpha=0 & beta=1), `pval_F', Holden-Peel T-Test (gamma=0), `tstat_gamma', p-value, `pval_gamma' ) excel dec(2) 
        }

// Export result to the master output file
import   delimited  "1reg_5Yrolling_`def_var'.txt",  clear
export   excel using "Output_IMFNowcasts_June27_2021.xlsx", sheet("Figure4.2_reg_`def_var'", replace)  firstrow(variables)



// plot coefficients of forecasts and 95% CI, export plot data		  
coefplot  yr1996 yr1997	yr1998	yr1999  yr2000 ///
          yr2001 yr2002	yr2003	yr2004	yr2005 yr2006	yr2007	yr2008 yr2009 yr2010 ///
		  yr2011 yr2012 yr2013	yr2014	yr2015 yr2016	yr2017	yr2018 yr2019 , ///
		  vertical drop(_cons) yline(1)  gen(ep_)  legend(col(5))

		  
// export data to make the graph easier to read
keep  ep_*
drop if ep_b==.
gen     endyear=1996
replace endyear=endyear - 1 +[_n]


// add marker to show bias and inefficiency
tsset    endyear, yearly
gen        mneumonic="`def_var'"

if  mneumonic  == "RENDA" {	
gen      biased=.
replace  biased = ep_b             if  inrange(endyear, 2000, 2003)  | inrange(endyear, 2007, 2010)   | inlist(endyear, 2013, 2014, 2016)
gen      inefficient=.
replace  inefficient=ep_b          if  inlist(endyear, 1996, 1997)  | inrange(endyear, 2000, 2004)  | inrange(endyear, 2006, 2009)   | inrange(endyear, 2013, 2016) 
gen      biased_inefficient=.
replace  biased_inefficient=ep_b   if biased != .   &  inefficient!=. 
gen      only_inefficient =.        
replace  only_inefficient = ep_b        if  inefficient!=. & biased==.

		 
twoway   (line ep_b endyear,  lwidth(thick)) ///
         (line ep_ll1 endyear,  lpattern(dash) lcolor(gs8)) ///
		 (line ep_ul1 endyear,  lpattern(dash) lcolor(gs8))  ///
		 (scatter only_inefficient endyear, mcolor(gold)  msize(medsmall) msymbol(0)) ///
		 (scatter biased endyear, mcolor(orange) msize(large) mlwidth(medthick) msymbol(O))  ///
		 (scatter biased_inefficient endyear, mcolor(gold)  msize(medsmall) msymbol(0)),  yline(1, lwidth(thick) lcolor(white) lpattern(solid)) ///
		 legend(order(1 "Coef of forecast" 2 "95% CI" 3 "95% CI" 4 "Inefficient" 5 "Biased") cols(3) position(6) ) ///
		 xlabel(1996(1)2019, labsize(small) angle(vertical) nogrid) title("(4.2c) Real Exchange Rate Growth", size(large)) ///
		 ylabel(, labsize(medlarge) angle(h)) ///
		 xtitle("End Year of the 5-year Rolling Window", size(medlarge)) ///
		 saving("`def_var'_5y_rolling", replace) name("`def_var'", replace)  scheme(plottig) aspect(0.5)		 
		 
}



grc1leg   NM_usd NX_usd RENDA, col(3) ring(0)  legendfrom(NM_usd) name(Fig4_2, replace) ///
          title("Nowcast Bias and Efficiency Over Time, 5-year Rolling Window")  subtitle("Non Hyperinflation & LIC")
graph     display Fig4_2, ysize(4) xsize(10)

// erase at the end
erase  "reg_5Yrolling_`def_var'.xls"
erase  "reg_5Yrolling_`def_var'.txt"
erase  tempdata.dta	

// regressions by nowcast month
*********************************************
// Figure 3: Forecast Horizons And Nowcast Accuracy 
// full sample
*********************************************
//set directory
cd "${path}"
clear
set more off
*****************  Import, full sample *****************  
use        "X_M_E_6-27-21_updated.dta", clear


local     def_var  = "NM_usd"	         // 1. rename variable here!!!!!!!!!!!!!

gen        mneumonic="`def_var'"
/*
use forecastdate, clear
replace mneumonic = "NM_usd" if inlist(mneumonic, "NM")
replace mneumonic = "NX_usd" if inlist(mneumonic, "NX")
save forecastdate_reina, replace
*/
merge 1:1  arrangementnumber mneumonic using forecastdate_reina
drop if    _m==2
drop       _m  mneumonic


rename     actual_`def_var'       actual       
rename     forecast_`def_var'     forecast    
rename     fe_imf_`def_var'       ferror
sum        actual forecast ferror

drop       type_new_LT_BOP // 2. omit this type (least obs)

replace   forecastdate = approvaldate    if arrangementnumber==624    // #624 Maldive

gen       int forecastmonth = month(forecastdate)
gen       int forecastyear = year(forecastdate)

gen       diff = programyear - forecastyear
order diff forecastdate forecastyear programyear approvaldate



// !!!! re-group obs into different months
replace   forecastmonth = 12      if   forecastyear>programyear   
replace   forecastmonth = 1       if   forecastyear<programyear   
	

	forvalues i=1(1)12 {
	
		* SJS F-test:
	reg       actual forecast         if forecastmonth == `i' , robust   // start with no control vairables at all
	est       store month_`i'  
	test      (_b[_cons]=0)           
	local     pval_alphais0=r(p)
	test      (_b[forecast]=1)           
	local     pval_betais1=r(p)
	test      (_b[_cons]=0) (_b[forecast]=1)  
	local     Fval=r(F)
	local     pval_F=r(p)
	local     adj_r=e(r2_a)
	* Holden-Peel T test:
	reg       ferror                  if forecastmonth == `i' , robust
	local     tstat_gamma = (_b[_cons]/_se[_cons]) 
	local     pval_gamma = tprob(e(df_r), abs(`tstat_gamma'))
	* Results output:
	outreg2   [month_`i']  using "reg_bymonth_`def_var'.xls", ///
	          adds(Adjusted R-squared, `adj_r', p-value (alpha=0), `pval_alphais0', p-value (beta=1), `pval_betais1', MZ F-test (alpha=0 & beta=1), `Fval', ///
	          p-value (alpha=0 & beta=1), `pval_F', Holden-Peel T-Test (gamma=0), `tstat_gamma', p-value, `pval_gamma' ) excel dec(2) 
        }



// Export result to the master output file
import   delimited  "reg_bymonth_`def_var'.txt",  clear
export   excel using "Output_IMFNowcasts_June27_2021.xlsx", sheet("Figure5_reg_`def_var'", replace)  firstrow(variables)
		
		
// plot coefficients of forecasts and 95% CI, export plot data		  
coefplot  month_1 month_2 month_3 month_4 month_5 month_6 month_7 month_8 month_9 month_10 month_11 month_12 , ///
		  vertical drop(_cons) yline(1)  gen(ep_)  legend(col(5))

		  
// export data to make the graph easier to read
keep  ep_*
drop if ep_b==.
save graphdata.dta, replace
gen  month = [_n]

gen        mneumonic="`def_var'"


// Graph full sample
if mneumonic  == "NM_usd" {	
gen      biased=.
replace  biased = ep_b             if inlist(month, 8) 
gen      inefficient=.
replace  inefficient=ep_b          if   inlist(month, 1, 2, 8, 9, 12)   
gen      biased_inefficient=.
replace  biased_inefficient=ep_b   if biased != .   &  inefficient!=. 
gen      only_inefficient =.        
replace  only_inefficient = ep_b        if  inefficient!=. & biased==.

twoway   (line ep_b month,  lwidth(thick)) ///
         (line ep_ll1 month,  lpattern(dash) lcolor(gs8)) ///
		 (line ep_ul1 month,  lpattern(dash) lcolor(gs8)) ///
		 (scatter only_inefficient month, mcolor(gold)  msize(medsmall) msymbol(0)) ///
         (scatter biased month, mcolor(orange) msize(large) mlwidth(medthick) msymbol(O))  ///
		 (scatter biased_inefficient month, mcolor(gold)  msize(medsmall) msymbol(0)),  yline(1, lwidth(thick) lcolor(white) lpattern(solid)) ///
         yla(-1 "-1"  0 "0" 1 "1" 2 "2" 3 "3", angle(h)) ///
		 legend(order(1 "Coef of forecast" 2 "95% CI" 3 "95% CI" 4 "Inefficient" 5 "Biased") cols(3) position(6) ) ///
		 xlabel(1 "Jan" 2 "Feb" 3 "Mar" 4 "Apr" 5 "May" 6 "June" 7 "July" 8 "Aug" 9 "Sep" 10 "Oct" 11 "Nov" 12 "Dec", ///
		 labsize(medium) nogrid) ylabel(, angle(h)) title("(3a) Import Growth", size(large)) ///
		 ylabel(, labsize(medlarge) angle(h)) ///
		 xtitle("Month of Nowcast", size(medlarge)) ///
		 saving("`def_var'_bymonth", replace) 	name("`def_var'", replace)  scheme(plottig) aspect(0.5)
		 
}


// erase at the end
erase  "reg_bymonth_`def_var'.xls"
erase  "reg_bymonth_`def_var'.txt"
		 
		 
		 
		 

*****************  NX_usd, full sample *****************  
use        "X_M_E_6-27-21_updated.dta", clear


local     def_var  = "NX_usd"	         // 1. rename variable here!!!!!!!!!!!!!

gen        mneumonic="`def_var'"
merge 1:1  arrangementnumber mneumonic using forecastdate_reina
drop if    _m==2
drop       _m  mneumonic


rename     actual_`def_var'       actual       
rename     forecast_`def_var'     forecast    
rename     fe_imf_`def_var'       ferror
sum        actual forecast ferror

drop       type_new_LT_BOP // 2. omit this type (least obs)

replace   forecastdate = approvaldate    if arrangementnumber==624    // #624 Maldive

gen       int forecastmonth = month(forecastdate)
gen       int forecastyear = year(forecastdate)

gen       diff = programyear - forecastyear
order diff forecastdate forecastyear programyear approvaldate



// !!!! re-group obs into different months
replace   forecastmonth = 12      if   forecastyear>programyear   
replace   forecastmonth = 1       if   forecastyear<programyear   
	

	forvalues i=1(1)12 {
	
		* SJS F-test:
	reg       actual forecast         if forecastmonth == `i' , robust   // start with no control vairables at all
	est       store month_`i'  
	test      (_b[_cons]=0)           
	local     pval_alphais0=r(p)
	test      (_b[forecast]=1)           
	local     pval_betais1=r(p)
	test      (_b[_cons]=0) (_b[forecast]=1)  
	local     Fval=r(F)
	local     pval_F=r(p)
	local     adj_r=e(r2_a)
	* Holden-Peel T test:
	reg       ferror                  if forecastmonth == `i' , robust
	local     tstat_gamma = (_b[_cons]/_se[_cons]) 
	local     pval_gamma = tprob(e(df_r), abs(`tstat_gamma'))
	* Results output:
	outreg2   [month_`i']  using "reg_bymonth_`def_var'.xls", ///
	          adds(Adjusted R-squared, `adj_r', p-value (alpha=0), `pval_alphais0', p-value (beta=1), `pval_betais1', MZ F-test (alpha=0 & beta=1), `Fval', ///
	          p-value (alpha=0 & beta=1), `pval_F', Holden-Peel T-Test (gamma=0), `tstat_gamma', p-value, `pval_gamma' ) excel dec(2) 
        }



// Export result to the master output file
import   delimited  "reg_bymonth_`def_var'.txt",  clear
export   excel using "Output_IMFNowcasts_June27_2021.xlsx", sheet("Figure5_reg_`def_var'", replace)  firstrow(variables)
		
		
// plot coefficients of forecasts and 95% CI, export plot data		  
coefplot  month_1 month_2 month_3 month_4 month_5 month_6 month_7 month_8 month_9 month_10 month_11 month_12 , ///
		  vertical drop(_cons) yline(1)  gen(ep_)  legend(col(5))

		  
// export data to make the graph easier to read
keep  ep_*
drop if ep_b==.
save graphdata.dta, replace
gen  month = [_n]

gen        mneumonic="`def_var'"


// Graph full sample
if mneumonic  == "NX_usd" {	
gen      biased=.
replace  biased = ep_b             if inlist(month, 3, 6, 7) 
gen      inefficient=.
replace  inefficient=ep_b          if inlist(month ,5 ,6,11)  
gen      biased_inefficient=.
replace  biased_inefficient=ep_b   if biased != .   &  inefficient!=. 
gen      only_inefficient =.        
replace  only_inefficient = ep_b        if  inefficient!=. & biased==.

twoway   (line ep_b month,  lwidth(thick)) ///
         (line ep_ll1 month,  lpattern(dash) lcolor(gs8)) ///
		 (line ep_ul1 month,  lpattern(dash) lcolor(gs8)) ///
		 (scatter only_inefficient month, mcolor(gold)  msize(medsmall) msymbol(0)) ///
         (scatter biased month, mcolor(orange) msize(large) mlwidth(medthick) msymbol(O))  ///
		 (scatter biased_inefficient month, mcolor(gold)  msize(medsmall) msymbol(0)),  yline(1, lwidth(thick) lcolor(white) lpattern(solid)) ///
         yla(-1 "-1"  0 "0" 1 "1" 2 "2" 3 "3", angle(h)) ///
		 legend(order(1 "Coef of forecast" 2 "95% CI" 3 "95% CI" 4 "Inefficient" 5 "Biased") cols(3) position(6) ) ///
		 xlabel(1 "Jan" 2 "Feb" 3 "Mar" 4 "Apr" 5 "May" 6 "June" 7 "July" 8 "Aug" 9 "Sep" 10 "Oct" 11 "Nov" 12 "Dec", ///
		 labsize(medium) nogrid) ylabel(, angle(h)) title("(3b) Export Growth", size(large)) ///
		 ylabel(, labsize(medlarge) angle(h)) ///
		 xtitle("Month of Nowcast", size(medlarge)) ///
		 saving("`def_var'_bymonth", replace) 	name("`def_var'", replace)  scheme(plottig) aspect(0.5)
		 
}


*****************  RENDA, full sample *****************  
use   "X_M_E_6-27-21_updated.dta", clear
/*
replace mneumonic = "RENDA" if inlist(mneumonic,"ENDA")
save forecastdate_reina, replace
*/
local     def_var  = "RENDA"	         // 1. rename variable here!!!!!!!!!!!!!

gen        mneumonic="`def_var'"
merge 1:1  arrangementnumber mneumonic using forecastdate_reina
drop if    _m==2
drop       _m  mneumonic


rename     actual_`def_var'       actual       
rename     forecast_`def_var'     forecast    
rename     fe_imf_`def_var'       ferror
sum        actual forecast ferror

drop       type_new_LT_BOP // 2. omit this type (least obs)

replace   forecastdate = approvaldate    if arrangementnumber==624    // #624 Maldive

gen       int forecastmonth = month(forecastdate)
gen       int forecastyear = year(forecastdate)

gen       diff = programyear - forecastyear
order diff forecastdate forecastyear programyear approvaldate



// !!!! re-group obs into different months
replace   forecastmonth = 12      if   forecastyear>programyear   
replace   forecastmonth = 1       if   forecastyear<programyear   
	

	forvalues i=1(1)12 {
	
		* SJS F-test:
	reg       actual forecast         if forecastmonth == `i' , robust   // start with no control vairables at all
	est       store month_`i'  
	test      (_b[_cons]=0)           
	local     pval_alphais0=r(p)
	test      (_b[forecast]=1)           
	local     pval_betais1=r(p)
	test      (_b[_cons]=0) (_b[forecast]=1)  
	local     Fval=r(F)
	local     pval_F=r(p)
	local     adj_r=e(r2_a)
	* Holden-Peel T test:
	reg       ferror                  if forecastmonth == `i' , robust
	local     tstat_gamma = (_b[_cons]/_se[_cons]) 
	local     pval_gamma = tprob(e(df_r), abs(`tstat_gamma'))
	* Results output:
	outreg2   [month_`i']  using "reg_bymonth_`def_var'.xls", ///
	          adds(Adjusted R-squared, `adj_r', p-value (alpha=0), `pval_alphais0', p-value (beta=1), `pval_betais1', MZ F-test (alpha=0 & beta=1), `Fval', ///
	          p-value (alpha=0 & beta=1), `pval_F', Holden-Peel T-Test (gamma=0), `tstat_gamma', p-value, `pval_gamma' ) excel dec(2) 
        }



// Export result to the master output file
import   delimited  "reg_bymonth_`def_var'.txt",  clear
export   excel using "Output_IMFNowcasts_June27_2021.xlsx", sheet("Figure5_reg_`def_var'", replace)  firstrow(variables)
		
		
// plot coefficients of forecasts and 95% CI, export plot data		  
coefplot  month_1 month_2 month_3 month_4 month_5 month_6 month_7 month_8 month_9 month_10 month_11 month_12 , ///
		  vertical drop(_cons) yline(1)  gen(ep_)  legend(col(5))

		  
// export data to make the graph easier to read
keep  ep_*
drop if ep_b==.
save graphdata.dta, replace
gen  month = [_n]

gen        mneumonic="`def_var'"


// Graph full sample
if  mneumonic  == "RENDA" {	
gen      biased=.
replace  biased = ep_b             if inlist(month, 5) 
gen      inefficient=.
replace  inefficient=ep_b          if inlist(month, 2, 5,7, 10)   
gen      biased_inefficient=.
replace  biased_inefficient=ep_b   if biased != .   &  inefficient!=. 
gen      only_inefficient =.        
replace  only_inefficient = ep_b        if  inefficient!=. & biased==.

twoway   (line ep_b month,  lwidth(thick)) ///
         (line ep_ll1 month,  lpattern(dash) lcolor(gs8)) ///
		 (line ep_ul1 month,  lpattern(dash) lcolor(gs8)) ///
		 (scatter only_inefficient month, mcolor(gold)  msize(medsmall) msymbol(0)) ///
         (scatter biased month, mcolor(orange) msize(large) mlwidth(medthick) msymbol(O))  ///
		 (scatter biased_inefficient month, mcolor(gold)  msize(medsmall) msymbol(0)),  yline(1, lwidth(thick) lcolor(white) lpattern(solid)) ///
         yla(-1 "-1"  0 "0" 1 "1" 2 "2" 3 "3", angle(h)) ///
		 legend(order(1 "Coef of forecast" 2 "95% CI" 3 "95% CI" 4 "Inefficient" 5 "Biased") cols(3) position(6) ) ///
		 xlabel(1 "Jan" 2 "Feb" 3 "Mar" 4 "Apr" 5 "May" 6 "June" 7 "July" 8 "Aug" 9 "Sep" 10 "Oct" 11 "Nov" 12 "Dec", ///
		 labsize(medium) nogrid) ylabel(, angle(h)) title("(3c) Real Exchange Rate Growth", size(large)) ///
		 ylabel(, labsize(medlarge) angle(h)) ///
		 xtitle("Month of Nowcast", size(medlarge)) ///
		 saving("`def_var'_bymonth", replace) 	name(RENDA, replace)  scheme(plottig) aspect(0.5)
		 
}

grc1leg   NM_usd NX_usd RENDA, col(3) ring(0)  legendfrom(NM_usd) name(Fig5, replace) ///
          title("Forecast Horizons And Nowcast Accuracy, by month of nowcasts")  subtitle("full sample")
graph     display Fig5, ysize(4) xsize(10)




// erase at the end
erase  "reg_bymonth_`def_var'.xls"
erase  "reg_bymonth_`def_var'.txt"

erase  RENDA_bymonth.gph
erase  NM_usd_bymonth.gph
erase  NX_usd_bymonth.gph

erase  NM_usd.gph
erase  NX_usd.gph		 		 
*erase  RENDA.gph

