setwd("~/Desktop/Nowcast Research/FX Research/Data file for Theo and Reina/input files_non-MONA")
library(haven)
X_M_E_6_27_21_updated <- read_stata("X_M_E_6-27-21_updated.dta")
library(tidyverse)
library(scales)
  
# NM
jpeg(file="plot1.jpeg")
  fig1=c()
  fig1=ggplot(X_M_E_6_27_21_updated, 
         aes(x = forecast_NM_usd, y = actual_NM_usd)) +
  geom_point(size=0.9)
  
  # change axis labels and axis scale
  fig1=fig1+stat_smooth(linetype="dashed",
                        method = "lm", se = T, color = "orange",
                        fullrange = TRUE, xseq = seq(-0.25,1.45, length=80))+
    scale_x_continuous(labels=c("0","0.5","1","1.5"),
                       breaks=c(0,0.5,1,1.5),
                     limits=c(-0.5, 1.58))+
       scale_y_continuous(labels=c("0","0.5","1","1.5","2","2.5"),
                        breaks=c(0,0.5,1,1.5,2,2.5),
                        limits=c(-0.6, 2.5))
 
  # add 45 degree line in segment 
  fig1=fig1+geom_segment(aes(x = -0.25, xend = 1.45, y = - 0.25, 
                             yend = 1.45),
                         size=0.8,
                         color="forestgreen")
  # add regression with with standard error segment
  
  fig1=fig1+theme(axis.text.y   = element_text(size=30,face="bold"),
        axis.text.x   = element_text(size=30,face="bold"),
        axis.title.y  = element_blank(),
        axis.title.x  = element_blank(),
        panel.background = element_blank(),
        panel.grid.major = element_blank(), 
        panel.grid.minor = element_blank(),
        axis.line = element_line(colour = "black"),
        panel.border = element_rect(colour = "black", fill=NA, size=1)
  )
  fig1
  dev.off()
  
  
  #NX
  
  jpeg(file="plot2.jpeg")
  fig1=c()
  fig1=ggplot(X_M_E_6_27_21_updated, 
              aes(x = forecast_NX_usd, y = actual_NX_usd)) +
    geom_point(size=0.9)
  
  # change axis labels and axis scale
  fig1=fig1+stat_smooth(linetype="dashed",
                        method = "lm", se = T, color = "orange",
                        fullrange = TRUE, xseq = seq(-0.33,1.23, length=80))+
    scale_x_continuous(labels=c("0","0.5","1"),
                       breaks=c(0,0.5,1),
                       limits=c(-0.33, 1.24))+
    scale_y_continuous(labels=c("0","0.5","1","1.5","2","2.5"),
                       breaks=c(0,0.5,1,1.5,2,2.5),
                       limits=c(-0.57, 2.5))
  
  # add 45 degree line in segment 
  fig1=fig1+geom_segment(aes(x = -0.33, xend = 1.23, y = - 0.33, 
                             yend = 1.23),
                         size=0.8,
                         color="forestgreen")
  # add regression with with standard error segment
  
  fig1=fig1+theme(axis.text.y   = element_text(size=30,face="bold"),
                  axis.text.x   = element_text(size=30,face="bold"),
                  axis.title.y  = element_blank(),
                  axis.title.x  = element_blank(),
                  panel.background = element_blank(),
                  panel.grid.major = element_blank(), 
                  panel.grid.minor = element_blank(),
                  axis.line = element_line(colour = "black"),
                  panel.border = element_rect(colour = "black", fill=NA, size=1)
  )
  fig1
  dev.off()
  
  #RENDA
  jpeg(file="plot3.jpeg")
  fig1=c()
  fig1=ggplot(X_M_E_6_27_21_updated, 
              aes(x = forecast_RENDA, y = actual_RENDA)) +
    geom_point(size=0.9)
  
  # change axis labels and axis scale
  fig1=fig1+stat_smooth(linetype="dashed",
                        method = "lm", se = T, color = "orange",
                        fullrange = TRUE, xseq = seq(-4,5, length=80))+
    scale_x_continuous(labels=c("-4","-3","-2","-1","0","1",
                                "2","3","4","5","6"),
                       breaks=c(-4:6),
                       limits=c(-4, 6))+
    scale_y_continuous(labels=c("-4","-3","-2","-1","0","1",
                                "2","3","4","5","6"),
                       breaks=c(-4:6),
                       limits=c(-4, 6))
  
  # add 45 degree line in segment 
  fig1=fig1+geom_segment(aes(x = -4, xend = 5, y = - 4, 
                             yend = 5),
                         size=0.8,
                         color="forestgreen")
  # add regression with with standard error segment
  
  fig1=fig1+theme(axis.text.y   = element_text(size=30,face="bold"),
                  axis.text.x   = element_text(size=30,face="bold"),
                  axis.title.y  = element_blank(),
                  axis.title.x  = element_blank(),
                  panel.background = element_blank(),
                  panel.grid.major = element_blank(), 
                  panel.grid.minor = element_blank(),
                  axis.line = element_line(colour = "black"),
                  panel.border = element_rect(colour = "black", fill=NA, size=1)
  )
  fig1
  dev.off()
  
  
  
  ##Varify the min and max points
  
  PerfectForecast=X_M_E_6_27_21_updated
  min(PerfectForecast$forecast_NX_usd,na.rm=T)
  min(PerfectForecast$actual_NX_usd,na.rm=T)
 
  max(PerfectForecast$forecast_NX_usd,na.rm=T)
  max(PerfectForecast$actual_NX_usd,na.rm=T)
  
  
  if(0)
  {set.seed(16)
  x = runif(100, 1, 9)
  y = -8.3 + (1/1.415)*x + rnorm(100)
  
  dat = data.frame(x, y)
  
  coef(lm(y~x))
  
  ggplot(dat, aes(x, y)) +
    geom_point() +
    geom_abline(intercept = -8.32, slope = 0.704) +
    xlim(1, 9)
  
  ggplot(dat, aes(x, y)) +
    geom_point() +
    geom_segment(aes(x = 1, xend = 9, y = -8.32 + .704, yend = -8.32 + .704*9),color="green") +
    xlim(1, 9)
  
  
  ggplot(dat, aes(x, y)) +
    geom_point() +
    stat_smooth(method = "lm", se = T, color = "orange") +
    xlim(1, 9)
  
  
 } 
  
  
  